elementary() {

  // new TTree created on the heap memory segment
  TTree* tree = new TTree("Tree Title", "Tree Label");
  
  // Branch with simple data type
  double energy;
  TBranch* branch = tree->Branch("Energy", &energy, "e/D");
 
  // Branch with a struct of simple data types
  struct Momentum {
    int particleType;
    double px;
    double py;
    double pz;
  } momentum;
  
  tree->Branch("P", &momentum, "pType/I:px/D:py/D:pz/D");
    

  // Filling the tree (this code is normally in an event-loop -
  // we will fill "manually" only 2 entries):

  // First entry:
  energy = 10.5;
  momentum.particleType = 7;
  momentum.px = 100.;
  momentum.py = 0.;
  momentum.pz = 70.;
  tree->Fill();

  // Second entry
  energy = 70.1;
  momentum.particleType = 1;
  momentum.px = 99.;
  momentum.py = 13.;
  momentum.pz = 5.;
  tree->Fill();

  // Now the tree would be saved ... But we keep it just to
  // demonstrate reading data from it


  // Here the tree would have been loaded from a file.

  // Now we demonstrate reading data from the tree:

  // Number of entries in the tree, i.e. number of leaves in each branch
  int no = tree->GetEntries();

  // Assign data structures to branches
  tree->SetBranchAddress("Energy", &energy); // Branch name "Energy" 
                                             // as in branch definition
  tree->SetBranchAddress("P", &momentum); // Branch name "P" as 
                                          // in branch defintion

  // Loop over entries in the tree - our data structurs will be
  // populated autmaticelly when calling tree.GetEntry(i)
  for ( int i=0; i<no; i++) {
    tree->GetEntry(i);
    
    // data is now in the assigned variables
    cout << "******** EVENTNO: " << i << " ********" << endl;
    cout << "ENERGY: " << energy << endl;
    cout << "PX: " <<momentum.px << " PTYPE: " << momentum.particleType << endl;
    cout << endl;
  }   

  
}
